﻿Public Class NormalForm

	Private Sub NormalForm_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load

		Me.imgMain.magnification = -1
        Me.imgMain.unitNo = Me.unitNo
        Me.tsbNormal.TabControl = Me.tcNormal
        Me.tcNormal.Update()

        Call setColorSpec()
        Call updateXYVal()

    End Sub

    Private Sub btnOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnOK.Click

        Me.DialogResult = Windows.Forms.DialogResult.OK

        Me.Close()
    End Sub

    Private Sub btnCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancel.Click

        Me.DialogResult = Windows.Forms.DialogResult.Cancel

        Me.Close()
    End Sub

    Private Sub btnHelp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnHelp.Click

    End Sub

	Private Sub tcNormal_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles tcNormal.SelectedIndexChanged

		Dim index As Integer = Me.tcNormal.SelectedIndex

		If (index >= 0) Then
			Me.tcNormal.TabPages(index).Controls.Add(Me.btnOK)
			Me.tcNormal.TabPages(index).Controls.Add(Me.btnCancel)
            Me.tcNormal.TabPages(index).Controls.Add(Me.btnHelp)
            Me.tcNormal.TabPages(index).Controls.Add(Me.imgMain)
            Me.tcNormal.TabPages(index).Controls.Add(Me.ZoomMain)
            Me.tcNormal.TabPages(index).Controls.Add(Me.Label1)
            Me.tcNormal.TabPages(index).Controls.Add(Me.vscRegion)

        End If

        If (index = 3 Or index = 4) Then
            Me.imgMain.subNo = vscRegion.Value + 1
        Else
            Me.imgMain.subNo = 0
        End If

    End Sub

    Private Sub vscRegion_ValueChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles vscRegion.ValueChanged

        setDataIdent()

        Dim index As Integer = Me.tcNormal.SelectedIndex
        If (index = 3 Or index = 4) Then
            Me.imgMain.subNo = vscRegion.Value + 1
        Else
            Me.imgMain.subNo = 0
        End If

    End Sub

    Private Sub setDataIdent()

        figureset.DataIdentNum_Figure = vscRegion.Value

        Me.cbColorSpecification.DataIdent = "R" + CStr(vscRegion.Value) + "colorSpecification"
        Me.colorSet.DataIdent_R = "R" + CStr(vscRegion.Value) + "colorR"
        Me.colorSet.DataIdent_G = "R" + CStr(vscRegion.Value) + "colorG"
        Me.colorSet.DataIdent_B = "R" + CStr(vscRegion.Value) + "colorB"
        Me.colorSet.DataIdent_GR = "R" + CStr(vscRegion.Value) + "colorDevR"
        Me.colorSet.DataIdent_GG = "R" + CStr(vscRegion.Value) + "colorDevG"
        Me.colorSet.DataIdent_GB = "R" + CStr(vscRegion.Value) + "colorDevB"

        Me.rdoColorIN.DataIdent = "R" + CStr(vscRegion.Value) + "detectionMode"
        Me.rdoColorOUT.DataIdent = "R" + CStr(vscRegion.Value) + "detectionMode"

        Me.stdsetReference.DataIdentPosX = "R" + CStr(vscRegion.Value) + "referencePosX"
        Me.stdsetReference.DataIdentPosY = "R" + CStr(vscRegion.Value) + "referencePosY"

        Me.numEdgeNo.DataIdent = "R" + CStr(vscRegion.Value) + "edgeNo"
        Me.rdoSou.DataIdent = "R" + CStr(vscRegion.Value) + "edgeLevelKind"
        Me.rdoZet.DataIdent = "R" + CStr(vscRegion.Value) + "edgeLevelKind"
        Call chgEdgeKind()
        Me.sldColorLevel.DataIdent = "R" + CStr(vscRegion.Value) + "colorLevel"
        Me.sldNoiseLevel.DataIdent = "R" + CStr(vscRegion.Value) + "noiseLevel"
        Me.valNoiseWidth.DataIdent = "R" + CStr(vscRegion.Value) + "noiseWidth"
        Me.limX.DataIdentLow = "R" + CStr(vscRegion.Value) + "lowerX"
        Me.limX.DataIdentUpp = "R" + CStr(vscRegion.Value) + "upperX"
        Me.limY.DataIdentLow = "R" + CStr(vscRegion.Value) + "lowerY"
        Me.limY.DataIdentUpp = "R" + CStr(vscRegion.Value) + "upperY"

        Me.rdoMonoDetectMode1.DataIdent = "R" + CStr(vscRegion.Value) + "monoDetectMode"
        Me.rdoMonoDetectMode2.DataIdent = "R" + CStr(vscRegion.Value) + "monoDetectMode"
        Me.numEdgeNoMono.DataIdent = "R" + CStr(vscRegion.Value) + "edgeNo"
        Me.rdoSouMono.DataIdent = "R" + CStr(vscRegion.Value) + "edgeLevelKind"
        Me.rdoZetMono.DataIdent = "R" + CStr(vscRegion.Value) + "edgeLevelKind"
        Me.sldEdgeLevelMono.DataIdent = Me.sldEdgeLevel.DataIdent
        Me.sldNoiseLevelMono.DataIdent = "R" + CStr(vscRegion.Value) + "noiseLevel"
        Me.valNoiseWidthMono.DataIdent = "R" + CStr(vscRegion.Value) + "noiseWidth"
        Me.limXMono.DataIdentLow = "R" + CStr(vscRegion.Value) + "lowerX"
        Me.limXMono.DataIdentUpp = "R" + CStr(vscRegion.Value) + "upperX"
        Me.limYMono.DataIdentLow = "R" + CStr(vscRegion.Value) + "lowerY"
        Me.limYMono.DataIdentUpp = "R" + CStr(vscRegion.Value) + "upperY"

        Call setColorSpec()
        Call updateXYVal()

    End Sub

    Private Sub ImageButton1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ImageButton1.Click

        ' Calculate reference position
        Me.UnitDataN("R" + CStr(vscRegion.Value) + "autoReference") = 0

        Me.stdsetReference.StopChangeEvent = True
        Me.stdsetReference.PositionX = Me.UnitDataN("R" + CStr(vscRegion.Value) + "referencePosX")
        Me.stdsetReference.PositionY = Me.UnitDataN("R" + CStr(vscRegion.Value) + "referencePosY")
        Me.stdsetReference.StopChangeEvent = False

        Me.imgMain.Refresh()

    End Sub

    Private Sub btnMeassure_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnMeassure.Click, btnMeassureMono.Click
        Me.UnitDataN("R" + CStr(vscRegion.Value) + "autoMeasure") = 0
        Call updateXYVal()

    End Sub

    Private Sub updateXYVal()
        Me.lblXVal.Text = Me.UnitDataN("R" + CStr(vscRegion.Value) + "positionX").ToString("f4")
        Me.lblYVal.Text = Me.UnitDataN("R" + CStr(vscRegion.Value) + "positionY").ToString("f4")
        Me.lblXValMono.Text = Me.UnitDataN("R" + CStr(vscRegion.Value) + "positionX").ToString("f4")
        Me.lblYValMono.Text = Me.UnitDataN("R" + CStr(vscRegion.Value) + "positionY").ToString("f4")

    End Sub

    Private Sub cbColorSpecification_CheckStateChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cbColorSpecification.CheckStateChanged
        Call setColorSpec()
    End Sub

    Private Sub setColorSpec()
        Dim status As Boolean
        status = Me.cbColorSpecification.Checked
        Me.colorSet.Enabled = status
        Me.rdoColorIN.Enabled = status
        Me.rdoColorOUT.Enabled = status
    End Sub

    Private Sub chgEdgeKind()
        If (Me.UnitDataN("R" + CStr(vscRegion.Value) + "edgeLevelKind") = 0) Then
            Me.sldEdgeLevel.MaxValue = 100
            Me.sldEdgeLevel.MinValue = 0
            Me.sldEdgeLevel.TickFrequency = 20
            Me.sldEdgeLevelMono.MaxValue = 100
            Me.sldEdgeLevelMono.MinValue = 0
            Me.sldEdgeLevelMono.TickFrequency = 20
            Me.sldEdgeLevel.DataIdent = "R" + CStr(vscRegion.Value) + "edgeLevel"
        Else
            Me.sldEdgeLevel.MaxValue = 442
            Me.sldEdgeLevel.MinValue = 0
            Me.sldEdgeLevelMono.MaxValue = 255
            Me.sldEdgeLevelMono.MinValue = 0
            Me.sldEdgeLevel.TickFrequency = 50
            Me.sldEdgeLevelMono.TickFrequency = 50
            Me.sldEdgeLevel.DataIdent = "R" + CStr(vscRegion.Value) + "edgeLevelAbs"
        End If

    End Sub



    Private Sub rdoSou_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rdoSou.CheckedChanged, rdoZetMono.CheckedChanged, rdoZet.CheckedChanged, rdoSouMono.CheckedChanged
        Call chgEdgeKind()
    End Sub

    Private Sub colorSet_ColorExtracted(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles colorSet.ColorExtracted

        If Me.cbColorSpecification.Checked = True Then
            Dim figureColor(0) As Integer
            Me.colorSet.GetFigureColor(figureColor)
            Me.SetUnitFigure(8, figureColor)

            Dim color As Integer = Me.UnitDataN("R0colorArea")
            Dim colorDev As Integer = Me.UnitDataN("R0colorDevArea")
            Me.colorSet.R = (color And &HFF0000) / &H10000
            Me.colorSet.G = (color And &HFF00) / &H100
            Me.colorSet.B = (color And &HFF)
            Me.colorSet.GR = (colorDev And &HFF0000) / &H10000
            Me.colorSet.GG = (colorDev And &HFF00) / &H100
            Me.colorSet.GB = (colorDev And &HFF)

        End If

    End Sub

    Private Sub figureset_FigureChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles figureset.FigureChanged
        Me.UnitDataN("R" + CStr(vscRegion.Value) + "autoReference") = 0
    End Sub

End Class

